﻿/*
	Copyright 2009 Intuitive Solutions

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

	   http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Gloo.Services.Automation.Mshtml;

namespace Gloo.Examples.Mshtml.HelloWorld
{
    public partial class HelloWorld : Form
    {
		Service s;

        public HelloWorld()
        {
            InitializeComponent();

			ServiceContainer sc = new ServiceContainer(wbContainer);

			s = new Service(sc);
			s.RegisterServiceListener(typeof(SearchService));

			wbContainer.Url = new Uri("http://www.google.com.co");
        }

        private void btnEnterInformation_Click(object sender, EventArgs e)
        {
			SearchService ss = new SearchService();

			ss.Query = "+IntuitiveSolutions +Metamorph";

			s.ExecuteAction(ss, "Search");
        }
    }
}
