﻿/*
	Copyright 2009 Intuitive Solutions

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

	   http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

using System;
using Gloo.Core.Services;

namespace Gloo.Examples.Mshtml.HelloWorld
{
    [ServiceProvider(ServiceType.Mshtml, ServiceContainer = "http://www.google.com.co")]
	public class SearchResultsService
    {
		protected string sQuery;
		protected SearchResultsRowService[] srrsRow;

		[ServiceParameter("//[@id='q']")]
		public string Query
		{
			get
			{
				return sQuery;
			}
			set
			{
				sQuery = value;
			}
		}

		[ServiceParameter("//div[@id='res']/div/ol/li")]
		public SearchResultsRowService[] Row
		{
			get
			{
				return srrsRow;
			}
			set
			{
				srrsRow = value;
			}
		}

		[ServiceAction("//[@id='btnG']")]
        public void Search()
        {
        }
    }
}
