﻿/*
	Copyright 2009 Intuitive Solutions

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

	   http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

using System;
using Gloo.Core.Services;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Reflection;
using mshtml;

namespace Gloo.Services.Automation.Mshtml
{
	public class Search
	{
		protected ServiceContainer scServiceContainer;

		public Search(ServiceContainer scServiceContainer)
		{
			this.scServiceContainer = scServiceContainer;
		}

		public object Fill(object oObject)
		{
			IHTMLElementCollection hecElementCollection = ((IHTMLDocument2)scServiceContainer.Container.Document.DomDocument).all;
			IHTMLElement heFoundElement = null;

			PropertyInfo[] pia = scServiceContainer.tObjectType.GetProperties();

			for (int i = 0; i < pia.Length; i++)
			{
				if (pia[i].GetCustomAttributes(typeof(ServiceParameterAttribute), true).Length > 0)
				{
					string sControl = ((ServiceParameterAttribute[])pia[i].GetCustomAttributes(typeof(ServiceParameterAttribute), true))[0].ParameterName;

					heFoundElement = (IHTMLElement)hecElementCollection.item(sControl, 0);

					if (heFoundElement != null)
					{
						((HTMLInputElement)heFoundElement).value = (string)pia[i].GetValue(oObject, null);
					}
				}
			}


			return oObject;
		}

		public string Find(string sId)
		{
			IHTMLElementCollection hecElementCollection = ((IHTMLDocument2)scServiceContainer.Container.Document.DomDocument).all;
			IHTMLElement heFoundElement = (IHTMLElement)hecElementCollection.item(sId, 0);

			return ((HTMLInputElement)heFoundElement).value;
		}
	}
}
